#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

 int main(void)
{
    /* Builtin functions */
    double sqrt(double), exp(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int k, m;
    static double y[2], h0, xk, xn, yn[2], yt[2], rab[1692];
    extern int de45d_c( );
    static double dely[2];
    static int imax, iniapr;
    static double relerr[2];

    m = 2;
    xn = sqrt(2.) * 3.;
    yn[0] = exp(xn * xn) * 3.;
    yn[1] = exp(-xn * xn) * .16666666666666666;
    yt[0] = 3.;
    yt[1] = .16666666666666666;
    xk = 0.0;
    h0 = -.1;
    k = 25;
    imax = 30;
    for (iniapr = 1; iniapr <= 2; ++iniapr) {
	h__ = h0;
	de45d_c((U_fp)f_c, &m, &xn, yn, &xk, &k, &iniapr, &imax, &h__, y, rab);

	dely[0] = yt[0] - y[0];
	dely[1] = yt[1] - y[1];
	relerr[0] = dely[0] / y[0];
	relerr[1] = dely[1] / y[1];

    printf("\n h0=%21.14e   k=%5i iniapr= %1i imax=%3i \n", h0, k, iniapr,imax);
    printf("\n y[0]= %21.14e y[1]=%21.14e\n",y[0],y[1]);
    printf("\n yt[0]=%21.14e y[1]= %21.14e\n",yt[0],yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e", dely[0], dely[1]);
    printf("\n relerr");
    printf("\n %23.14e %23.14e \n\n", relerr[0], relerr[1]);

    }
    return 0;
} /* main */

 int f_c(double *x, double *y, double *z__, int *m)
{
    /* Parameter adjustments */
    --z__;
    --y;

    /* Function Body */
    z__[1] = *x / y[2];
    z__[2] = -(*x) / y[1];
    return 0;
} /* f_c */
